<?php
/**
 * Class represents records from table pages
 * {autogenerated}
 * @property int $page_id 
 * @property string $title 
 * @property string $desc 
 * @property string $path 
 * @property int $use_layout 
 * @property string $html 
 * @property datetime $dattm 
 * @see Am_Table
 */
class Page extends ResourceAbstract 
{
    public function getUrl()
    {
        return REL_ROOT_URL . "/content/p/id/" . $this->page_id."/";
    }
}

class PageTable extends ResourceAbstractTable {
    protected $_key = 'page_id';
    protected $_table = '?_page';
    protected $_recordClass = 'Page';
    
    public function getAccessType()
    {
        return ResourceAccess::PAGE;
    }
    public function getAccessTitle()
    {
        return ___('Pages');
    }
    public function getPageId()
    {
        return 'pages';
    }
}
